/********************************************************************************************************
*
* File                : tc.c
* Hardware Environment: 
* Build Environment   : ST Visual Develop 4.1.6
* Version             : V1.0
* By                  : Xiao xian hui
*
*                                  (c) Copyright 2005-2010, WaveShare
*                                       http://www.waveShare.net
*                                          All Rights Reserved
*
*********************************************************************************************************/

#include "STM8_TSL_RC_API.h"
#include <stm8s208mb.h>
#include <system2.h>
#include <ws_lcd_st7920.h>

u8 silder1;

#define LED1_ON()  State1 = ON;
#define LED1_OFF() State1 = OFF;

#define LED2_ON()  State2 = ON;
#define LED2_OFF() State2 = OFF;

#define LED3_ON()  State3 = ON;
#define LED3_OFF() State3 = OFF;

typedef enum
{
  OFF = 0,
  ON = 1
} LedState_T;

LedState_T State1,State2,State3;

//--------    SECTION DEFINITION FOR THIS FILE   --------------
#if defined(__CSMC__) && defined(USE_PRAGMA_SECTION)
#pragma section [CONFIG_RAM]
#pragma section @tiny [CONFIG_RAM0]
#pragma section (CONFIG_CODE)
#pragma section const {CONFIG_CONST}
#endif

void ExtraCode_Init(void);
void ExtraCode_StateMachine(void);


void main(void)
{

	CLK->CKDIVR = 0x00; // Main freq divided by 1 = Full Freq
	
	TSL_Init();
	ExtraCode_Init();
	
  for (;;) {
    
		ExtraCode_StateMachine();
		
    TSL_Action();
   
	}
  
}

void ExtraCode_Init(void)
{

  u8 i;
	
	  for (i = 0; i < NUMBER_OF_SINGLE_CHANNEL_KEYS; i++)
  {
    sSCKeyInfo[i].Setting.b.IMPLEMENTED = 1;
    sSCKeyInfo[i].Setting.b.ENABLED = 1;
    sSCKeyInfo[i].DESGroup = 0x01; /* Put 0x00 to disable the DES on these pins */
  }
	
#if NUMBER_OF_MULTI_CHANNEL_KEYS > 0
  for (i = 0; i < NUMBER_OF_MULTI_CHANNEL_KEYS; i++)
  {
    sMCKeyInfo[i].Setting.b.IMPLEMENTED = 1;
    sMCKeyInfo[i].Setting.b.ENABLED = 1;
    sMCKeyInfo[i].DESGroup = 0x01; /* Put 0x00 to disable the DES on these pins */
  }
#endif

  enableInterrupts();
	
  delay_ms(900);
	st7920LcdInit();
	showLine(0,0,lcd_buffer,"0 0 0");
	showLine(0,1,lcd_buffer,"Low        High");
	showLine(0,2,lcd_buffer,">");
	showLine(6,3,lcd_buffer,"000");
	refreshLCD(lcd_buffer);
}


void ExtraCode_StateMachine(void)	
{
	u8 temp,i;
  if((TSL_GlobalSetting.b.LOCKED) && (silder1!=sMCKeyInfo[0].UnScaledPosition))
	{
		silder1=sMCKeyInfo[0].UnScaledPosition;
		temp=((u8)sMCKeyInfo[0].UnScaledPosition)/17;
		
		for(i=0;i<temp;i++)
		{
			showLine(i,2,lcd_buffer,">");
		}
		for(i=i+1;i<16;i++)
		{
			showLine(i,2,lcd_buffer," ");
		}
		showLine(6,3,lcd_buffer,"%d3",(u16)sMCKeyInfo[0].UnScaledPosition);
		refreshLCD(lcd_buffer);
	}
	
	if ((TSL_GlobalSetting.b.CHANGED) && (TSLState == TSL_IDLE_STATE))
  {
   
		TSL_GlobalSetting.b.CHANGED = 0;
    
    if (sSCKeyInfo[0].Setting.b.DETECTED) /* KEY 1 touched */
    {
      if (State1 == OFF)
      {
        LED1_ON();
				showLine(0,0,lcd_buffer,"1");
				refreshLCD(lcd_buffer);
      }
      else
      {
        LED1_OFF();
				showLine(0,0,lcd_buffer,"0");
				refreshLCD(lcd_buffer);
      }
    }
   
    if (sSCKeyInfo[1].Setting.b.DETECTED) /* KEY 2 touched */
    {
      if (State2 == OFF)
      {
        LED2_ON();
				showLine(2,0,lcd_buffer,"1");
				refreshLCD(lcd_buffer);
      }
      else
      {
        LED2_OFF();
				showLine(2,0,lcd_buffer,"0");
				refreshLCD(lcd_buffer);
      }
    }
    
    if (sSCKeyInfo[2].Setting.b.DETECTED) /* KEY 3 touched */
    {
      if (State3 == OFF)
      {
        LED3_ON();
				showLine(4,0,lcd_buffer,"1");
				refreshLCD(lcd_buffer);
      }
      else
      {
        LED3_OFF();
				showLine(4,0,lcd_buffer,"0");
				refreshLCD(lcd_buffer);
      }
    }
  }
}